/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


diaryControllers.controller('DiaryCtrl', function ($scope, $log, Configuration, $state, $uibModal, DiaryService, $filter, 
uibDateParser, RunScheduleReportService, ViewReportService,ActionFactory,ActionDefinitions) {
    DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;
    });


    //Getting the request types and adding them to the filter dropdown
    DiaryService.getRequestTypes().then(function (types) {
        $scope.requestTypes = types.data;
        $scope.filterSelected.requestTypes = angular.copy($scope.requestTypes);
        $scope.filterSelected.requestTypes.push($scope.filterSelected.requestType);
    });


    $scope.filterSelected = {};
    $scope.filterSelected.employee = undefined;
    $scope.filterSelected.requestType = {id: 0, description: 'All'};

    $scope.currentRequestType = {id: 0, description: 'All'};
    $scope.loadingRequestSpinner = "";


    $scope.fromDate = new Date();
    $scope.toDate = new Date();
    $scope.driverId = null;

    $scope.businessEntities = DiaryService.getCustomers();
    $scope.actionTypes = DiaryService.getActionTypes();
//    DiaryService.getRequests().then(function (requests) {
//        $scope.requests = requests.data;
//        //$scope.requests[0].actions = $scope.myTestTasks;
//        console.log("the request is");
//        console.log($scope.requests);
//
//        $scope.requestGridOptions.data = $scope.requests;
//
//
//
//
//    });

    $scope.load = function () {
        console.log($scope.filterSelected.employee);
        $scope.loadingRequestSpinner = "glyphicon glyphicon-refresh spinning";
        if ($scope.filterSelected.employee !== undefined) {
            $scope.driverId = $scope.filterSelected.employee.id;
        }
        ;
        $scope.fromDate.setHours(00);
        $scope.fromDate.setMinutes(00);
        $scope.toDate.setHours(23);
        $scope.toDate.setMinutes(59);

        $scope.filterBean = {
            fromDate: $scope.fromDate,
            toDate: $scope.toDate,
            driverId: $scope.driverId,
            requestTypeId: $scope.filterSelected.requestType.id
        };

        DiaryService.requestSearch($scope.filterBean).then(function (requests) {
            $scope.requests = requests.data;
            console.log("the request is");
            console.log($scope.requests);
            $scope.requestGridOptions.data = $scope.requests;

            $scope.currentRequestType = $scope.filterSelected.requestType;
            $scope.loadingRequestSpinner = "";
        });

    };

    var date = new Date();


    $scope.requestGridOptions = {
        rowTemplate: 'templates/diary/requestRowTemplate.html',
        columnDefs: [
            {field: 'requestId', name: 'ID', type: 'number'},
            {field: 'runCategory.description', name: 'Run'},
            {field: 'employee.name', name: 'Employee'},
            {field: 'driver.name', name: 'Driver'},
            {field: 'company.name', name: 'Company', cellTooltip:
                        function (row, col) {
                            return row.entity.company.address;
                        }
            },
            {field: 'address.address', name: 'Site',
                cellTemplate: '<div title="{{COL_FIELD}}" class="ui-grid-cell-contents ">{{COL_FIELD | split : \'\\n\' : 0 }}</div>',
                cellTooltip:
                        function (row, col) {
                            return row.entity.address.address;
                        }
            },
            {field: 'contact.name', name: 'Contact', cellTooltip:
                        function (row, col) {
                            var details = "";
                            angular.forEach(row.entity.contact.contactDetails, function (each) {
                                details = details + each.contactDetailCategoryId.description + " : "
                                        + each.detailData + "\n";
                            });
                            return details;
                        }},
            {field: 'orderNumber', name: 'Order No'},
            {field: 'equipementDetails', name: 'Equipment', cellTooltip:
                        function (row, col) {
                            return row.entity.equipementDetails;
                        }},
            {field: 'priceAgreed', name: 'Price Agreed'},
            {field: 'transportDetails', name: 'Transport'},
            {field: 'requiredDate', name: 'Expected', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}
        ]
    };

    $scope.isRequestSelected = function (rowEntity) {
        if ($scope.contextMenuEntity == null)
            return false;
        return $scope.contextMenuEntity.requestId === rowEntity.requestId;
    };

    $scope.isActionSelected = function (rowEntity) {
        if ($scope.contextMenuEntityAction == null)
            return false;
        return $scope.contextMenuEntityAction.id === rowEntity.id;
    };
    
    $scope.getActionStatusColor = function(rowEntity){
        var color = '';
        if( rowEntity.dateCompleted !== null ){
            if (rowEntity.success) {
                color = 'actionsuccess';
            }else{
                $log.info( "setting to red" );
                color = 'actionfailed';
            };
        };
        if( $scope.isActionSelected(rowEntity) ){
            color = 'rowselected';
        }
        return color;
    };

    $scope.newAction = function (action) {
        if ($scope.selectedRequest != null) {
            $scope.selectedAction = action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/modals/newActionModal.html',
                controller: 'newActionModalCtrl',
                size: 'lg',
                scope: $scope
            });
        }
    };



    $scope.taskGridOptions = {
        rowTemplate: 'templates/diary/actionRowTemplate.html',
        columnDefs: [
            {field: 'actionType.description', name: 'Action'},
            {field: 'actionPriority.description', name: 'Priority'},
            {field: 'actorPersonId.name', name: 'Actor'},
            {field: 'acteePersonId.name', name: 'Actee'},
            {field: 'comment', name: 'Description'},
            {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
            {field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

        ]
    };

    console.log($scope.requestGridOptions.data);

    //$scope.gridOptions = $scope.myTestTasks;
    //$scope.myTasks = $scope.myTestTasks;
    $scope.myData = $scope.myTestData;
    $scope.filterText;
    $scope.filterGrid = {};
    $scope.filterGrid.data = $scope.myData;

    $scope.refreshData = function () {
        console.log($scope.filterGrid1);
        $scope.filterGrid.data = $filter('filter')($scope.myData, $scope.filterText, undefined);
    };

    $scope.getTasks = function (row) {
        $scope.selectedRequest = row.row.entity;
        $scope.taskGridOptions.data = $scope.selectedRequest.actions;
    };

    $scope.onRowHover = function (row) {
        //console.log(row);
        //$scope.description = row.row.entity.Description;
        // console.log($scope.element);
        //$scope.description = $scope.element.entity.Description;
        // console.log($scope.description);
        //};
    };

    $scope.menuOption = [
        ['Buy', function ($itemScope) {
                $scope.player.gold -= $itemScope.item.cost;
            }]
                //null,
                ['Sell', function ($itemScope) {
                    $scope.player.gold += $itemScope.item.cost;
                }]
    ];
    // todo 
    $scope.logout = function () {
        Configuration.clearLoginConfiguration();
        $state.go('login');
    };


    //Bootsrap Modal Controller
    $scope.items = ['item1', 'item2', 'item3'];

    $scope.animationsEnabled = true;

    $scope.selectedRequestEntity = function (rowEntity) {
        $log.info(rowEntity);
        $scope.contextMenuEntity = rowEntity;
    };

    $scope.selectedActionEntity = function (rowEntity) {
        $scope.contextMenuEntityAction = rowEntity;
    };

    $scope.open = function (data, header) {
        $scope.data = data;
        console.log("this is the data");
        console.log(data);
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: 'templates/modals/newEditModal.html',
            controller: 'ModalInstanceCtrl',
            //size: 'lg',
            windowClass: 'request-modal-window',
            scope: $scope,
            resolve: {
                details: function () {
                    if ($scope.data.company != null) {
                        $scope.details = $scope.data;
                        // console.log($scope.details);
                    } else
                    {
                        $scope.details = {};
                        //$scope.details.requestType = $scope.data;
                        //console.log("the new data is");
                        //console.log($scope.details);
                    }


                    return $scope.details;
                },
//                contacts: function () {
//                    $scope.contacts = $scope.businessEntities;
//                    console.log( "In the open modal logic contacts are");
//                    console.log($scope.contacts);
//                    return $scope.contacts;
//                },
                header: function () {
                    $scope.header = header;
                    if ($scope.header != true) {
                        $scope.header = "Edit Information";
                    } else
                    {
                        $scope.header = "New Request";
                    }
                    return $scope.header;
                },
                diaries: function () {
                    return $scope.myData;
                }
            }
        });

        modalInstance.result.then(function (selectedItem) {
            $scope.selected = selectedItem;
            
            $log.info("$scope.selected");
            $log.info($scope.selected);
            $log.info($scope.details);

            $log.info("$scope.selected.requestData");
            $log.info($scope.selected.requestData);
            
            if ( $scope.selected.requestData != null ){
                angular.forEach($scope.requestGridOptions.data,function(each){
                    if( each.requestId === $scope.selected.requestData.requestId ){
                       $scope.contextMenuEntity = each;
                       $scope.selectedRequest = each;
                       $scope.taskGridOptions.data = $scope.selectedRequest.actions;
                    }; 
                });
            };


            if ($scope.selected.available === false && !ActionFactory.checkActionTypeExists($scope.selectedRequest , ActionDefinitions.get().availablitycheck) ) {
                var availabilityCheckAction = ActionFactory.buildNewPendingAction({ actionType: {id: ActionDefinitions.get().type.availablitycheck,description:'Check Availablity' },
                        actionPriority: { id: ActionDefinitions.get().priority.high ,description: 'High'} ,actorPersonId: $scope.selectedRequest.employee , 
                        acteePersonId: $scope.selectedRequest.contact  ,createdByPersonId: $scope.selectedRequest.employee  ,requestId: $scope.selectedRequest.requestId  } );
                
                $scope.newAction(availabilityCheckAction);
            };

            if ($scope.selected.createOrder) {
                // create our order ( seperate controller class and service )
                 $scope.editDocument();
            };


        }, function () {
            $log.info('Modal dismissed at: ' + new Date());
        });
    };


    $scope.editDocument = function () {
        if ($scope.selectedRequest != null) {
            var documentInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/document/documentEditorModal.html',
                controller: 'DocumentEditorModalCtrl',
                windowClass: 'request-modal-window',
                scope: $scope
            });
            
            documentInstance.result.then(function (selectedItem) {
                
            });
        }
    };

    $scope.deleteAction = function (action) {
        console.log(action);

    }

    $scope.rightClick = function (data) {
        console.log("right clicked on");
        console.log(data.row.entity);

    };

    $scope.toggleAnimation = function () {
        $scope.animationsEnabled = !$scope.animationsEnabled;
    };


    $scope.today = function () {
        $scope.dt = new Date();
    };
    $scope.today();

    $scope.clear = function () {
        $scope.dt = null;
    };

    $scope.inlineOptions = {
        //customClass: getDayClass,
        minDate: new Date(),
        showWeeks: true
    };

    $scope.dateOptions = {
        // dateDisabled: disabled,
        formatYear: 'yy',
        maxDate: new Date(2020, 5, 22),
        minDate: new Date(),
        startingDay: 1
    };

    // Disable weekend selection
    function disabled(data) {
        var date = data.date,
                mode = data.mode;
        return mode === 'day' && (date.getDay() === 0 || date.getDay() === 5);
    }

    $scope.toggleMin = function () {
        $scope.inlineOptions.minDate = $scope.inlineOptions.minDate ? null : new Date();
        $scope.dateOptions.minDate = $scope.inlineOptions.minDate;
    };

    $scope.toggleMin();

    $scope.open1 = function () {
        $scope.popup1.opened = true;
    };

    $scope.open2 = function () {
        $scope.popup2.opened = true;
    };

    $scope.setDate = function (year, month, day) {
        $scope.dt = new Date(year, month, day);
    };

    $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
    $scope.format = $scope.formats[0];
    $scope.altInputFormats = ['M!/d!/yyyy'];


    //From date popup
    $scope.popup1 = {
        opened: false
    };

    //To Date popup
    $scope.popup2 = {
        opened: false
    };


    //Deleting 
    $scope.remove = function (item, action) {
        console.log("I've been clicked");
        console.log(item);
        $scope.data = item;
        $scope.actionBool = action
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: 'templates/modals/deleteModal.html',
            controller: 'DeleteModalCtrl',
            size: 'sm',
            scope: $scope
        });

        modalInstance.result.then(function (selectedItem) {
            $scope.selected = selectedItem;
            //console.log($scope.selected);
            //console.log($scope.details);


        }, function () {
            $log.info('Modal dismissed at: ' + new Date());
        });
    };




    $scope.newDiary = function (item) {
        console.log("this is the request");
        console.log(item);


        $scope.open(item, item);

    };

    $scope.viewRunScheduleReport = function () {
        RunScheduleReportService.runScheduleReport({beans: $scope.requestGridOptions.data}).then(function (data) {
            $log.info(data.data);
            ViewReportService.viewReport(data.data);
        });
       
    };


});




diaryControllers.controller('ModalInstanceCtrl', function ($q, $scope, $log, $uibModalInstance, details, header,
        DiaryService, diaries, bsLoadingOverlayService, $filter, focus, $uibModal,ActionFactory,ActionDefinitions) {
    var emailCategory = 1;
    var mainLineCategory = 2;
    var mobileCategory = 3;
    var faxCategory = 4;

    $scope.header = header;
    $scope.selected = {};
    //$scope.contacts = [];
    $scope.selectedCustomer = details.company;
    if ($scope.selectedCustomer != null) {
        $scope.selectedCustomerAddress = $scope.selectedCustomer.address;
    }

    /*$scope.setANewSite = function () {
     $scope.selected.Site = {id: 0, name: 'A New Site', address: '', lat: 0, lng: 0, postcode: null, active: true, businessEntityId: 0};
     };*/

    $scope.setANewContact = function () {
        $scope.selected.Contact = undefined;
        $scope.setContactDetails();
        focus('ANewContact');
    };

    $scope.selected.Site = details.address;
    if (details.address === undefined) {
        //$scope.setANewSite();
    } else {
        $scope.selected.Site.name = $filter('split')(details.address.address, '\n', 0);
    }
    console.log("the selected site is");
    console.log(details);
    if ($scope.selected.Site != null) {
        $scope.selectedSiteAddress = $scope.selected.Site.address;
    }
    //$scope.contacts = contacts;
    $scope.selected.Contact = details.contact;
    $scope.detailData = {};




    $scope.setContactDetails = function () {
        console.log("the contact is");
        console.log($scope.selected.Contact)
        if ($scope.selected.Contact != null && $scope.selected.Contact.contactDetails != null) {
            for (var i = 0; i < $scope.selected.Contact.contactDetails.length; i++)
            {
                console.log("the selectedContact details are");
                console.log($scope.selected.Contact.contactDetails[i]);
                if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == emailCategory)
                {
                    $scope.detailData.email = $scope.selected.Contact.contactDetails[i];
                } else if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == mainLineCategory)
                {
                    $scope.detailData.phone = $scope.selected.Contact.contactDetails[i];
                } else if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == mobileCategory) {
                    $scope.detailData.mobile = $scope.selected.Contact.contactDetails[i];
                } else if ($scope.selected.Contact.contactDetails[i].contactDetailCategoryId.id == faxCategory) {
                    $scope.detailData.fax = $scope.selected.Contact.contactDetails[i];
                }
            }
        } else {
            $scope.detailData.email = "";
            $scope.detailData.phone = "";
            $scope.detailData.mobile = "";
            $scope.detailData.fax = "";
        }
    };
    if ($scope.selected.Contact != null) {
        $scope.setContactDetails();
    }


    $scope.loading = true;





    bsLoadingOverlayService.start();

    var initialize = function () {
        $scope.selectedPerson = undefined;

        $scope.diaries = diaries;
        console.log("the details are");
        console.log(details);
        if (details.company != undefined || details.company != null) {
            //Get all the seperate information to stop binding if the user 
            //changes something but then cancels it won't affect the code

            // angular.clone does this.

            $scope.selectedDetails = details
            console.log("the selected details are");
            console.log($scope.selectedDetails);
            //$scope.selectedPriority = details.Priority;

            //We want to get the site for the selected company




            $scope.selectedCustomer = details.company;
            $scope.selectedCustomerAddress = details.company.address;
            // $scope.selectedSiteAddress = details.site.address;
            $scope.selected.Contact = details.contact;
            $scope.selected.Site = details.address;
            $scope.selectedDescription = details.equipementDetails;
            $scope.selected.Operator = details.employee;
            $scope.selectedTransportDetails = details.transportDetails;
            $scope.selectedOrderNumber = details.orderNumber;
            $scope.selectedPriceAgreed = details.priceAgreed;
            $scope.selectedTransport = details.transportDetails;
            $scope.selectedDateTime = Date.parse(details.requiredDate);
            $scope.selectedType = details.runCategory;
            $scope.selectedRequestType = details.requestType;
            $scope.selected.available = false; // need to work this out from actions ( ie successful Availability action )
            $scope.selected.createOrder = false;

        } else {
            $scope.selectedDateTime = new Date();
            $scope.selectedRequestType = $scope.requestTypes[0];
            $scope.selected.available = false;
            $scope.selected.createOrder = false;
        }
        $scope.loading = false;
        bsLoadingOverlayService.stop();

        console.log("Sites and Contacts");
        console.log($scope.sites);
        console.log($scope.contacts);
        console.log("------------------");


    };

    var allTasks = [];
    allTasks.push(DiaryService.getCustomers().then(function (customers) {
        $scope.persons = customers.data;
    }));
    ;

    allTasks.push(DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;


        if ($scope.selectedCustomer == null) {
            angular.forEach($scope.employees, function (each) {
                if (each.id === parseInt(localStorage.operatorId)) {
                    $scope.selected.Operator = each;
                }
                ;
            });
        }
        ;
    }));
    allTasks.push(DiaryService.getRunCategories().then(function (runTypes) {
        $scope.types = runTypes.data;
        $scope.setType($scope.types[0]);
        $log.info("finished runCategories");
    }));

    if (details.company !== undefined) {
        allTasks.push(DiaryService.getSites(details.company.id).then(function (siteList) {
            $scope.sites = siteList.data;
        }));
        allTasks.push(DiaryService.getContacts(details.company.id).then(function (contactList) {
            $scope.contacts = contactList.data;
        }));
    }

    $q.all(allTasks).then(function (data) {
        initialize();
        $log.info("Finished AllTasks");
    },
            function (error) {
                initialize();
                $log.info("Finished AllTasks");
            });



    $scope.changed = function () {
        $log.info($scope.selectedDateTime);

    };


    $scope.setCustomer = function (data) {
        console.log(data);
        $scope.selectedCustomer = data;
        $scope.selectedCustomerName = data.name;
        $scope.selectedCustomerAddress = $scope.selectedCustomer.address
        DiaryService.getSites($scope.selectedCustomer.id).then(function (siteList) {
            $scope.sites = siteList.data;
        });
        DiaryService.getContacts($scope.selectedCustomer.id).then(function (contactList) {
            $scope.contacts = contactList.data;
        });
        $scope.selected.Contact = null;
        //$scope.setANewSite(); // we will always have at least one site entry the "A New Site" 
    };

    $scope.setContact = function (data) {
        $scope.selected.Contact = data;
        $scope.setContactDetails();
    };

    $scope.setSite = function (data) {
        $scope.selected.Site = data;
        $scope.selectedSiteAddress = $scope.selected.Site.address

        //$scope.setContactDetails();
    };

    $scope.setPriority = function (data) {
        $scope.selectedPriority = data;
        console.log($scope.selectedPriority);
    };

    $scope.setType = function (data) {
        $scope.selectedType = data;
        console.log($scope.selectedType);

    };

    $scope.setRequestType = function (data) {
        $scope.selectedRequestType = data;
        console.log($scope.selectedRequestType);

    };

    $scope.setEmployee = function (data) {
        $scope.selected.Operator = data;
        console.log($scope.selected.Operator);
    };


    $scope.diaryDetails = details;
    $scope.selected = {
        //item: $scope.items[0]
    };

    $scope.ok = function (data) {
        console.log("the details are");
        console.log(details);
        
        var refreshRequests = function(){
            DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                    $scope.requests = requests.data;
                    $scope.requestGridOptions.data = $scope.requests;
                    $uibModalInstance.close($scope.details);
                });
        };

        $scope.createRequest = function () {
            console.log("creating request");
            console.log($scope.details);
            DiaryService.createRequest($scope.details).then(function (request) {
                console.log("synced");
                console.log(request);
                
                $scope.details.requestData = request.data;

                
                if( $scope.selected.available && !ActionFactory.checkActionTypeExists(request.data , ActionDefinitions.get().type.availablitycheck ) ){
                    $log.info("Creating completed AvailabilityCheck Action");
                    var availabilityCheckAction = ActionFactory.buildNewCompletedAction({ actionType: {id: ActionDefinitions.get().type.availablitycheck },
                        actionPriority: { id: ActionDefinitions.get().priority.high } ,actorPersonId: request.data.employee , 
                        acteePersonId: request.data.contact  ,createdByPersonId: request.data.employee  ,requestId: request.data.requestId  } );
                    DiaryService.createAction( availabilityCheckAction ).then(function (data) {
                      refreshRequests();
                    });
                }else{
                    refreshRequests();
                };
            });
        };

        $scope.setDetails = function () {
            $scope.details = {
                operator: $scope.selected.Operator,
                company: $scope.selectedCustomer,
                address: $scope.selected.Site,
                contact: $scope.selected.Contact,
                equipementDetails: $scope.selectedDescription,
                employee: $scope.selected.Operator,
                transportDetails: $scope.selectedTransportDetails,
                orderNumber: $scope.selectedOrderNumber,
                priceAgreed: $scope.selectedPriceAgreed,
                requiredDate: $scope.selectedDateTime,
                requestType: $scope.selectedRequestType.id,
                runCategory: $scope.selectedType,
                requestId: 0,
                creationDate: new Date(),
                descripton: "test",
                available: $scope.selected.available,
                createOrder: $scope.selected.createOrder,
                requestData: $scope.requestData,
                requestStatus: {
                    id: 1,
                    description: "Unassigned"
                }
            }

            $scope.createRequest();
        };

        $scope.checkCustomer = function (newRequest) {
            //Checking to see if we're creating a new contact.
            console.log("this is the customer");
            console.log($scope.selectedCustomer);
            if ($scope.selectedCustomer != null) {
                if ($scope.selectedCustomer.id == null) {
                    DiaryService.buildNewBusiness($scope.selectedCustomerAddress, $scope.selectedCustomer).then(function (data) {
                        console.log("the customer bean is");
                        console.log(data);
                        $scope.selectedCustomer = data;
                        //$scope.details.contact = $scope.selected.Contact;
                        $scope.checkContact(newRequest);
                    });
                } else
                {
                    $scope.checkContact(newRequest);
                }

            }
        };

        $scope.checkContact = function (newRequest) {
            console.log("this is the contact");
            console.log($scope.selected.Contact)
            if ($scope.selected.Contact != null) {
                //if ($scope.selected.Contact.id == null) {
                DiaryService.buildContact($scope.selected.Contact, $scope.detailData).then(function (data) {
                    console.log("the contact bean is");
                    console.log(data);
                    $scope.selected.Contact = data;
                    $scope.details.contact = $scope.selected.Contact;


                    console.log("new Details addedd");
                    console.log($scope.details);
                    $scope.checkSite(newRequest);

                });
                // } else {
                //     $scope.checkSite(newRequest);
                // }

            } else {
                $scope.checkSite(newRequest);
            }
        };

        $scope.checkSite = function (newRequest) {
            if ($scope.selected.Site != null) {

                /*if ($scope.selected.Site.id == 0) {
                 $scope.selected.Site.address;
                 DiaryService.buildNewSite($scope.address).then(function (data) {
                 console.log("the site bean is");
                 console.log(data);
                 $scope.selected.Site = data;
                 $scope.details.site = $scope.selected.Site;
                 
                 
                 console.log("new Details addedd");
                 console.log($scope.details);
                 if (newRequest == true) {
                 $scope.setDetails();
                 } else {
                 $scope.createRequest();
                 }
                 
                 
                 });
                 } else*/ {
                    if (newRequest == true) {
                        $scope.setDetails();
                    } else {
                        $scope.createRequest();
                    }
                }


            } else {
                if (newRequest == true) {
                    $scope.setDetails();
                } else {
                    $scope.createRequest();
                }
            }
        };

        if (details.company == undefined || details.company == null) {
            console.log("creating new request");

            //Checking to see if we're creating a new contact.
            console.log("the customer is");

            console.log($scope.selectedCustomer);
            if ($scope.selectedCustomer != null) {
                //Beginning process to save 
                $scope.checkCustomer(true);
            }





            //$scope.diaries.push($scope.diaryDetails);
        } else {
            $scope.details = details;
            $scope.selectedCustomer.address = $scope.selectedCustomerAddress;
            console.log($scope.selectedCustomer);
            console.log($scope.selected.Site);
            console.log($scope.selectedDateTime);
            console.log($scope.selectedDescription);

            console.log($scope.details);
            $scope.details.actions = null;

            if ($scope.selectedCustomer != undefined || $scope.selectedCustomer != null) {
                $scope.details.company = $scope.selectedCustomer;
            }
            ;
            if ($scope.selected.Site != undefined || $scope.selected.Site != null) {
                // $scope.selected.Site.address = $scope.selectedSiteAddress;
                $scope.details.address = $scope.selected.Site;
            }
            ;
            //$scope.details.contact = $scope.selected.Contact;
            $scope.details.equipementDetails = $scope.selectedDescription;
            $scope.details.employee = $scope.selected.Operator;
            $scope.details.transportDetails = $scope.selectedTransportDetails;
            $scope.details.orderNumber = $scope.selectedOrderNumber;
            $scope.details.priceAgreed = $scope.selectedPriceAgreed;
            $scope.details.transportDetails = $scope.selectedTransport;
            $scope.details.requiredDate = new Date($scope.selectedDateTime);
            $scope.details.runCategory = $scope.selectedType;
            $scope.details.requestType = $scope.selectedRequestType.id;
            $scope.details.available = $scope.selected.available;
            $scope.details.createOrder = $scope.selected.createOrder;


            $scope.details.requestStatus = {
                id: 1,
                description: "Unassigned"
            }
            console.log("the details are");
            console.log($scope.details);

            $scope.checkCustomer(false);



        }
        
    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };
});


diaryControllers.controller('DeleteModalCtrl', function ($scope, $log, DiaryService, $uibModalInstance) {
    $scope.details = $scope.data;
    $scope.oldrequestGridOptions = $scope.requestGridOptions;
    $scope.oldTaskGridOptions = $scope.taskGridOptions;
    console.log($scope.details);
    console.log($scope.actionBool);
    if ($scope.actionBool != true) {
        $scope.message = "Do you want to delete this request?";
        $scope.item = 'request';
    } else
    {
        $scope.message = "Do you want to delete this action?"
        $scope.item = 'action';
    }

    $scope.ok = function (data) {
        if ($scope.actionBool != true) {
            $scope.id = $scope.details.requestId
            DiaryService.deleteRequest($scope.id).then(function (siteList) {
                console.log("deleted");
                console.log(siteList.data);
                DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                    $scope.requests = requests.data;
                    $scope.oldrequestGridOptions.data = $scope.requests;

                    console.log("this is the actions");
                    console.log($scope.taskGridOptions);
                });
                $scope.oldTaskGridOptions.data = {};
            });
        } else
        {

            $scope.id = $scope.details.id;
            DiaryService.deleteAction($scope.id).then(function (siteList) {
                console.log("deleted");
                console.log(siteList.data);

                for (var i = 0; i < $scope.requests.length; i++) {

                    if ($scope.requests[i].requestId === $scope.details.requestId) {

                        $scope.oldTaskGridOptions.data = $scope.requests[i].actions;
                    }

                }

                DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                    $scope.requests = requests.data;
                    $scope.oldrequestGridOptions.data = $scope.requests;
                    console.log($scope.requests);
                    console.log("this is the actions");
                    console.log($scope.taskGridOptions);

                    for (var i = 0; i < $scope.requests.length; i++) {

                        if ($scope.requests[i].requestId === $scope.details.requestId) {

                            $scope.oldTaskGridOptions.data = $scope.requests[i].actions;
                        }

                    }
                });




            });
        }
        $uibModalInstance.close($scope.details);
    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };

});


diaryControllers.controller('newActionModalCtrl', function ($q, $scope, $log, DiaryService, $uibModalInstance, bsLoadingOverlayService) {
    $scope.oldrequestGridOptions = $scope.requestGridOptions;
    $scope.oldTaskGridOptions = $scope.taskGridOptions;
    $scope.request = angular.copy($scope.selectedRequest);
    $scope.oldSelectedAction = $scope.selectedAction;

    if ($scope.selectedAction != null) {
        $scope.selected = angular.copy($scope.selectedAction);
        console.log($scope.selected);
        $scope.selected.dateScheduled = new Date($scope.selected.dateScheduled);


        if ($scope.selected.dateCompleted != null) {
            $scope.selected.dateCompleted = new Date($scope.selected.dateCompleted);
        }
        ;

    } else {
        $scope.selected = {};
        $scope.selected.id = 0;
        $scope.selected.seq = 0;
        $scope.selected.actionType = {};
        $scope.selected.actorPersonId = {};
        $scope.selected.acteePersonId = $scope.request.contact;
        $scope.selected.comment = null;
        $scope.selected.createdByPersonId = {};
        $scope.selected.dateCompleted = null;
        $scope.selected.dateCreated = new Date();
        $scope.selected.dateScheduled = new Date();
        $scope.selected.requestId = $scope.selectedRequest.requestId;
    }

    $scope.completed = false;
    $log.info("$scope.selected.dateCompleted");
    $log.info($scope.selected.dateCompleted);
    if ($scope.selected.dateCompleted != null) {
        $scope.completed = true;
    }
    ;

    $scope.loading = true;
    bsLoadingOverlayService.start();
    var promiseTasks = [];
    promiseTasks.push(DiaryService.getPriorities().then(function (priorities) {
        $scope.states = priorities.data;
        if ($scope.selected.actionPriority == null) {
            $scope.selected.actionPriority = $scope.states[0];
        }
    }));
    promiseTasks.push(DiaryService.getActionTypes().then(function (types) {
        console.log("the actions are");
        $scope.types = types.data;

        $log.info( "$scope.selected.actionType.id" );
        $log.info( $scope.selected.actionType.id );

        if ($scope.selected.actionType.id === undefined) {
            $scope.selected.actionType = $scope.types[0];
        }
        ;
    }));
    promiseTasks.push(DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;

        if ($scope.selected.id === 0) {
            angular.forEach($scope.employees, function (each) {
                $log.info("each.id === localStorage.operatorId ");
                $log.info(each.id);
                $log.info(localStorage.operatorId);

                if (each.id === parseInt(localStorage.operatorId)) {
                    $scope.selected.createdByPersonId = each;
                }
                ;
            });
        }
        ;
    }));

    if ($scope.selectedRequest.company !== undefined) {
        promiseTasks.push(DiaryService.getContacts($scope.selectedRequest.company.id).then(function (contactList) {
            $scope.contacts = contactList.data;

        }));
    }
    ;

    $q.all(promiseTasks).then(function (data) {
        bsLoadingOverlayService.stop();
        $scope.loading = false;
    },
            function (failed) {
                bsLoadingOverlayService.stop();
                $scope.loading = false;
            });


    $scope.actionDatePopup = {
        opened: false
    };

    $scope.actionDateOpen = function () {

        $scope.actionDatePopup.opened = true;

    };

    $scope.actionCompletedDatePopup = {
        opened: false
    };

    $scope.actionCompletedDateOpen = function () {

        $scope.actionCompletedDatePopup.opened = true;

    };

    $scope.setAction = function (action) {
        $scope.selectedAction = action;
    };

    $scope.setPriority = function (priority) {
        $scope.selected.actionPriority = priority;
    };

    // how much the hours and mins increment
    $scope.hstep = 1;
    $scope.mstep = 1;

    $scope.toggleCompleted = function () {
        $log.info("toggled");
        if ($scope.completed === true) {
            $log.info("true")
            $scope.selected.dateCompleted = new Date();
            $scope.selected.success = true;
        } else {
            $log.info("False");
            $scope.selected.dateCompleted = null;
            $scope.selected.success = false;
        }
        $log.info("Completed Date");
        $log.info($scope.selected.dateCompleted)
    };

    $scope.actionOk = function (data) {



        console.log("the actions are");
        console.log($scope.taskGridOptions.data);

        DiaryService.createAction($scope.selected).then(function (data) {
            console.log("synced");
            console.log(data.data);
            $scope.oldSelectedAction = $scope.selected;
            if ($scope.oldSelectedAction.id == 0) {
                $scope.oldTaskGridOptions.data.push($scope.oldSelectedAction);
            } else
            {
                console.log("in the else beginning loop");
                for (var i = 0; i < $scope.oldTaskGridOptions.data.length; i++)
                {
                    console.log("the action ids are");
                    console.log($scope.oldTaskGridOptions.data[i].id + "-" + $scope.oldSelectedAction.id)
                    if ($scope.oldTaskGridOptions.data[i].id === $scope.oldSelectedAction.id)
                    {
                        $scope.oldTaskGridOptions.data[i] = $scope.oldSelectedAction;
                    }
                }
            }


            DiaryService.requestSearch($scope.filterBean).then(function (requests) {
                $scope.requests = requests.data;
                $scope.oldrequestGridOptions.data = $scope.requests;

                console.log("this is the actions");
                console.log($scope.taskGridOptions);

                for (var i = 0; i < $scope.requests.length; i++) {
                    console.log("the ids are");
                    console.log($scope.requests[i].requestId + "-" + $scope.oldSelectedAction.requestId);
                    if ($scope.requests[i].requestId === $scope.oldSelectedAction.requestId) {
                        console.log("in fors if getting new actions");
                        $scope.oldTaskGridOptions.data = $scope.requests[i].actions;
                    }

                }

            });
        });
        $uibModalInstance.close($scope.details);
    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };

});
