/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


diaryDirectives.directive('clickCapture', function() {
  return {
    link: function(scope, elm, attrs) {
      elm.bind('click', function() {
        //Clicks on the body close all drop downs.
        $(elm).find("[data-drop-down] ul").addClass('menu-closed');
      });
    }
  }
});

diaryDirectives.directive('focusOn', function() {
   return function(scope, elem, attr) {
      scope.$on('focusOn', function(e, name) {
        if(name === attr.focusOn) {
          elem[0].focus();
        }
      });
   };
});

diaryDirectives.directive('toggleButton', function () {
        return {
            restrict: 'A',
            transclude: true,
            replace: false,
            require: 'ngModel',
            link: function ($scope, $element, $attr, require) {
                var ngModel = require;
                // update model from Element
                var updateModelFromElement = function () {
                    // If modified
                    var checked = $element.prop('checked');
                    if (checked != ngModel.$viewValue) {
                        // Update ngModel
                        ngModel.$setViewValue(checked);
                        $scope.$apply();
                    }
                };

                // Update input from Model
                var updateElementFromModel = function () {
                    // Update button state to match model
                    $element.trigger('change');
                };

                // Observe: Element changes affect Model
                $element.on('change', function () {
                    updateModelFromElement();
                });

                // Observe: ngModel for changes
                $scope.$watch(function () {
                    return ngModel.$viewValue;
                }, function () {
                    updateElementFromModel();
                });

                // Initialise BootstrapToggle
                console.log($element);
                $element.bootstrapToggle({ on: $attr.on, off: $attr.off, size:$attr.size, onstyle: $attr.onstyle, offstyle: $attr.offstyle, style: $attr.style, width: $attr.width, height: $attr.height });
            }
        };
    });
    
diaryDirectives.directive('toggleCheckbox', [
     function toggleCheckbox() {
        /**
         * Directive
         */
        return {
            restrict: 'A',
            transclude: true,
            replace: false,
            require: 'ngModel',
            link: function ($scope, $element, $attr, ngModel) {

                // update model from Element
                var updateModelFromElement = function() {
                    // If modified
                    var checked = $element.prop('checked');
                    if (checked != ngModel.$viewValue) {
                        // Update ngModel
                        ngModel.$setViewValue(checked);
                        $scope.$apply();
                    }
                };

                // Update input from Model
                var updateElementFromModel = function(newValue) {
                    $element.trigger('change');
                };

                // Observe: Element changes affect Model
                $element.on('change', function() {
                    updateModelFromElement();
                });

                $scope.$watch(function() {
                  return ngModel.$viewValue;
                }, function(newValue) { 
                  updateElementFromModel(newValue);
                }, true);

                // Initialise BootstrapToggle
                $element.bootstrapToggle({ on: $attr.on, off: $attr.off, size:$attr.size, onstyle: $attr.onstyle, offstyle: $attr.offstyle, style: $attr.style, width: $attr.width, height: $attr.height });
            }
        };
    }]);